freeslot("S_DRIFTBOOSTFLAME", "SPR_DRPO")

local cv_flame = CV_RegisterVar {
	name = "dvfx_flame",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
}

states[S_DRIFTBOOSTFLAME] = {
	sprite = SPR_DRPO,
	frame = A|FF_ANIMATE|FF_FULLBRIGHT,
	tics = TICRATE,
	var1 = 5,
	var2 = 2,
	nextstate = S_NULL,
}

-- O p t i m i z a t i o n
local S_DRIFTBOOSTFLAME = S_DRIFTBOOSTFLAME
local MAXSKINCOLORS = MAXSKINCOLORS

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if mo.eflags & MFE_VERTICALFLIP then
		mo.z = $ + master.height - FixedMul(master.scale, mo.height)
	end
end

DVFX_OnDriftRelease(function(p, level)
	if cv_flame.value == 0 then return end

	local driftvfx = DVFX_GetData(p)
	
	local overlay = driftvfx.driftboostoverlay
	
	if not (overlay and overlay.valid and overlay.state == S_DRIFTBOOSTFLAME) then
		overlay = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BOOSTFLAME)
		driftvfx.driftboostoverlay = overlay
	end

	overlay.target = p.mo
	overlay.state = S_DRIFTBOOSTFLAME
	overlay.extravalue1 = 1
	overlay.destscale = p.mo.scale
	
	if DVFX_DoBlending() then
		overlay.blendmode = AST_ADD
	end
	
	P_SetScale(overlay, overlay.destscale)
	K_FlipFromObject(overlay, p.mo)
	
	if level == 1 then
		overlay.color = SKINCOLOR_SAPPHIRE
		overlay.tics = overlay.tics/2 -- Less time for blue drift
	elseif level == 2 then
		overlay.color = SKINCOLOR_KETCHUP
	elseif level == 3 then
		overlay.extravalue2 = 1
		overlay.tics = 5*overlay.tics/2 -- More time for rainbow drift
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo.valid and mo.target and mo.extravalue1 == 1) then
		return
	end
	
	if mo.target.player.kartstuff[k_driftboost] == 0 then
		P_RemoveMobj(mo)
		return
	end
	
	mo.movecount = INT32_MAX -- Don't let kart turn this back into normal boostflame
	mo.spritexoffset = mo.target.spritexoffset
	mo.spriteyoffset = mo.target.spriteyoffset
	mo.rollangle = mo.target.rollsum
	
	local TRANS = FF_TRANS50
	
	if leveltime % 2 == 1 then
		mo.frame = mo.frame | TRANS
	else
		mo.frame = mo.frame & ~TRANS
	end
	
	if mo.extravalue2 == 1 then
		mo.color = (1 + (leveltime % (MAXSKINCOLORS-1)))
	end
end, MT_BOOSTFLAME)